package cyberdeliaengine

class Vector3D(_x:Float,_y:Float,_z:Float) {
    var x:Float = _x
    var y:Float = _y
    var z:Float = _z

    constructor() : this(0f,0f,0f)

    init {
    }

    fun set(_x:Float,_y:Float,_z:Float) {
        x = _x
        y = _y
        z = _z
    }

    operator fun plus(v:Vector3D): Vector3D {
        val v2 = Vector3D()
        v2.x = x + v.x
        v2.y = y + v.y
        v2.z = z + v.z
        return v2
    }

    operator fun minus(v:Vector3D): Vector3D {
        val v2 = Vector3D()
        v2.x = x - v.x
        v2.y = y - v.y
        v2.z = z - v.z
        return v2
    }

    fun crossProduct(v:Vector3D): Vector3D {
        val v2 = Vector3D()
        v2.x = y * v.z - v.y * z
        v2.y = v.x * z - x * v.z
        v2.z = x * v.y - v.x * y
        return v2
    }

    fun dotProduct(v:Vector3D): Float {
        return v.x * x + v.y * y + v.z * z
    }
}